"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const assert = require("assert");
const ttm = require("vsts-task-lib/mock-test");
const path = require("path");
function ApplicationInsightsTests() {
    it('azure-arm-appinsights-webtests ApplicationInsightsWebTests', (done) => {
        let tp = path.join(__dirname, 'azure-arm-appinsights-webtests-tests.js');
        let tr = new ttm.MockTestRunner(tp);
        let passed = true;
        try {
            tr.run();
            assert(tr.succeeded, "azure-arm-appinsights-tests should have passed but failed.");
            console.log("\tvalidating list");
            list(tr);
            console.log("\tvalidating create");
            create(tr);
        }
        catch (error) {
            passed = false;
            console.log(tr.stdout);
            console.log(tr.stderr);
            done(error);
        }
        if (passed) {
            done();
        }
    });
}
exports.ApplicationInsightsTests = ApplicationInsightsTests;
function list(tr) {
    assert(tr.stdOutContained('retrieved list of tests for MOCK_RESOURCE_GROUP_NAME.'), 'Should have printed: retrieved list of tests for MOCK_RESOURCE_GROUP_NAME.');
    assert(tr.stdOutContained('WEB TEST COUNT: 2'), 'Should have printed: WEB TEST COUNT: 2');
}
function create(tr) {
    assert(tr.stdOutContained('FailedToCreateWebTests'), 'Should have printed: FailedToCreateWebTests');
    assert(tr.stdOutContained('added web test MOCK_TEST_1.'), 'added web test MOCK_TEST_1.');
}
