import { AzureEndpoint, AzureAppServiceConfigurationDetails } from './azureModels';
import { ServiceClient } from './AzureServiceClient';
export declare class AzureAppService {
    private _resourceGroup;
    private _name;
    private _slot;
    private _appKind;
    _client: ServiceClient;
    private _appServiceConfigurationDetails;
    private _appServicePublishingProfile;
    private _appServiceApplicationSetings;
    constructor(endpoint: AzureEndpoint, resourceGroup: string, name: string, slot?: string, appKind?: string);
    start(): Promise<void>;
    stop(): Promise<void>;
    restart(): Promise<void>;
    swap(slotName: string, preserveVNet?: boolean): Promise<void>;
    get(force?: boolean): Promise<AzureAppServiceConfigurationDetails>;
    getPublishingProfileWithSecrets(force?: boolean): Promise<any>;
    getPublishingCredentials(): Promise<any>;
    getApplicationSettings(force?: boolean): Promise<AzureAppServiceConfigurationDetails>;
    updateApplicationSettings(applicationSettings: any): Promise<AzureAppServiceConfigurationDetails>;
    patchApplicationSettings(properties: any): Promise<void>;
    getConfiguration(): Promise<AzureAppServiceConfigurationDetails>;
    updateConfiguration(applicationSettings: any): Promise<AzureAppServiceConfigurationDetails>;
    patchConfiguration(properties: any): Promise<any>;
    getMetadata(): Promise<AzureAppServiceConfigurationDetails>;
    updateMetadata(applicationSettings: any): Promise<AzureAppServiceConfigurationDetails>;
    patchMetadata(properties: any): Promise<void>;
    getSlot(): string;
    private _getPublishingProfileWithSecrets();
    private _getApplicationSettings();
    private _get();
    private _getFormattedName();
    getName(): string;
}
