"use strict";
var MockAnswers = (function () {
    function MockAnswers() {
    }
    MockAnswers.prototype.initialize = function (answers) {
        if (!answers) {
            throw new Error('Answers not supplied');
        }
        this._answers = answers;
    };
    MockAnswers.prototype.getResponse = function (cmd, key, debug) {
        debug("looking up mock answers for " + JSON.stringify(cmd) + ", key '" + JSON.stringify(key) + "'");
        if (!this._answers) {
            throw new Error('Must initialize');
        }
        if (!this._answers[cmd]) {
            debug("no mock responses registered for given cmd");
            return null;
        }
        if (this._answers[cmd][key]) {
            debug('found mock response');
            return this._answers[cmd][key];
        }
        if (key && process.env['MOCK_NORMALIZE_SLASHES'] === 'true') {
            // try normalizing the slashes
            var key2 = key.replace(/\\/g, "/");
            if (this._answers[cmd][key2]) {
                debug('found mock response for normalized key');
                return this._answers[cmd][key2];
            }
        }
        debug('mock response not found');
        return null;
    };
    return MockAnswers;
}());
exports.MockAnswers = MockAnswers;
